"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseAddMetadataInstruction = exports.getAddMetadataInstruction = exports.getAddMetadataInstructionDataCodec = exports.getAddMetadataInstructionDataDecoder = exports.getAddMetadataInstructionDataEncoder = void 0;
const web3_js_1 = require("@solana/web3.js");
const programs_1 = require("../programs");
const shared_1 = require("../shared");
const types_1 = require("../types");
function getAddMetadataInstructionDataEncoder() {
    return (0, web3_js_1.transformEncoder)((0, web3_js_1.getStructEncoder)([
        ['discriminator', (0, web3_js_1.fixEncoderSize)((0, web3_js_1.getBytesEncoder)(), 8)],
        ['args', (0, web3_js_1.getArrayEncoder)((0, types_1.getAddMetadataArgsEncoder)())],
    ]), (value) => ({
        ...value,
        discriminator: new Uint8Array([231, 195, 40, 240, 67, 231, 53, 136]),
    }));
}
exports.getAddMetadataInstructionDataEncoder = getAddMetadataInstructionDataEncoder;
function getAddMetadataInstructionDataDecoder() {
    return (0, web3_js_1.getStructDecoder)([
        ['discriminator', (0, web3_js_1.fixDecoderSize)((0, web3_js_1.getBytesDecoder)(), 8)],
        ['args', (0, web3_js_1.getArrayDecoder)((0, types_1.getAddMetadataArgsDecoder)())],
    ]);
}
exports.getAddMetadataInstructionDataDecoder = getAddMetadataInstructionDataDecoder;
function getAddMetadataInstructionDataCodec() {
    return (0, web3_js_1.combineCodec)(getAddMetadataInstructionDataEncoder(), getAddMetadataInstructionDataDecoder());
}
exports.getAddMetadataInstructionDataCodec = getAddMetadataInstructionDataCodec;
function getAddMetadataInstruction(input) {
    // Program address.
    const programAddress = programs_1.WEN_NEW_STANDARD_PROGRAM_ADDRESS;
    // Original accounts.
    const originalAccounts = {
        payer: { value: input.payer ?? null, isWritable: true },
        authority: { value: input.authority ?? null, isWritable: false },
        mint: { value: input.mint ?? null, isWritable: true },
        systemProgram: { value: input.systemProgram ?? null, isWritable: false },
        tokenProgram: { value: input.tokenProgram ?? null, isWritable: false },
    };
    const accounts = originalAccounts;
    // Original args.
    const args = { ...input };
    // Resolve default values.
    if (!accounts.systemProgram.value) {
        accounts.systemProgram.value =
            '11111111111111111111111111111111';
    }
    if (!accounts.tokenProgram.value) {
        accounts.tokenProgram.value =
            'TokenzQdBNbLqP5VEhdkAS6EPFLC1PHnBqCXEpPxuEb';
    }
    const getAccountMeta = (0, shared_1.getAccountMetaFactory)(programAddress, 'programId');
    const instruction = {
        accounts: [
            getAccountMeta(accounts.payer),
            getAccountMeta(accounts.authority),
            getAccountMeta(accounts.mint),
            getAccountMeta(accounts.systemProgram),
            getAccountMeta(accounts.tokenProgram),
        ],
        programAddress,
        data: getAddMetadataInstructionDataEncoder().encode(args),
    };
    return instruction;
}
exports.getAddMetadataInstruction = getAddMetadataInstruction;
function parseAddMetadataInstruction(instruction) {
    if (instruction.accounts.length < 5) {
        // TODO: Coded error.
        throw new Error('Not enough accounts');
    }
    let accountIndex = 0;
    const getNextAccount = () => {
        const accountMeta = instruction.accounts[accountIndex];
        accountIndex += 1;
        return accountMeta;
    };
    return {
        programAddress: instruction.programAddress,
        accounts: {
            payer: getNextAccount(),
            authority: getNextAccount(),
            mint: getNextAccount(),
            systemProgram: getNextAccount(),
            tokenProgram: getNextAccount(),
        },
        data: getAddMetadataInstructionDataDecoder().decode(instruction.data),
    };
}
exports.parseAddMetadataInstruction = parseAddMetadataInstruction;
//# sourceMappingURL=addMetadata.js.map