"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseApproveTransferInstruction = exports.getApproveTransferInstruction = exports.getApproveTransferInstructionDataCodec = exports.getApproveTransferInstructionDataDecoder = exports.getApproveTransferInstructionDataEncoder = void 0;
const web3_js_1 = require("@solana/web3.js");
const programs_1 = require("../programs");
const shared_1 = require("../shared");
function getApproveTransferInstructionDataEncoder() {
    return (0, web3_js_1.transformEncoder)((0, web3_js_1.getStructEncoder)([
        ['discriminator', (0, web3_js_1.fixEncoderSize)((0, web3_js_1.getBytesEncoder)(), 8)],
        ['buyAmount', (0, web3_js_1.getU64Encoder)()],
    ]), (value) => ({
        ...value,
        discriminator: new Uint8Array([198, 217, 247, 150, 208, 60, 169, 244]),
    }));
}
exports.getApproveTransferInstructionDataEncoder = getApproveTransferInstructionDataEncoder;
function getApproveTransferInstructionDataDecoder() {
    return (0, web3_js_1.getStructDecoder)([
        ['discriminator', (0, web3_js_1.fixDecoderSize)((0, web3_js_1.getBytesDecoder)(), 8)],
        ['buyAmount', (0, web3_js_1.getU64Decoder)()],
    ]);
}
exports.getApproveTransferInstructionDataDecoder = getApproveTransferInstructionDataDecoder;
function getApproveTransferInstructionDataCodec() {
    return (0, web3_js_1.combineCodec)(getApproveTransferInstructionDataEncoder(), getApproveTransferInstructionDataDecoder());
}
exports.getApproveTransferInstructionDataCodec = getApproveTransferInstructionDataCodec;
function getApproveTransferInstruction(input) {
    // Program address.
    const programAddress = programs_1.WEN_NEW_STANDARD_PROGRAM_ADDRESS;
    // Original accounts.
    const originalAccounts = {
        payer: { value: input.payer ?? null, isWritable: true },
        authority: { value: input.authority ?? null, isWritable: true },
        mint: { value: input.mint ?? null, isWritable: false },
        approveAccount: { value: input.approveAccount ?? null, isWritable: true },
        paymentMint: { value: input.paymentMint ?? null, isWritable: false },
        distributionTokenAccount: {
            value: input.distributionTokenAccount ?? null,
            isWritable: true,
        },
        authorityTokenAccount: {
            value: input.authorityTokenAccount ?? null,
            isWritable: true,
        },
        distributionAccount: {
            value: input.distributionAccount ?? null,
            isWritable: true,
        },
        systemProgram: { value: input.systemProgram ?? null, isWritable: false },
        distributionProgram: {
            value: input.distributionProgram ?? null,
            isWritable: false,
        },
        tokenProgram: { value: input.tokenProgram ?? null, isWritable: false },
        paymentTokenProgram: {
            value: input.paymentTokenProgram ?? null,
            isWritable: false,
        },
    };
    const accounts = originalAccounts;
    // Original args.
    const args = { ...input };
    // Resolve default values.
    if (!accounts.systemProgram.value) {
        accounts.systemProgram.value =
            '11111111111111111111111111111111';
    }
    if (!accounts.distributionProgram.value) {
        accounts.distributionProgram.value =
            'diste3nXmK7ddDTs1zb6uday6j4etCa9RChD8fJ1xay';
    }
    if (!accounts.tokenProgram.value) {
        accounts.tokenProgram.value =
            'TokenzQdBNbLqP5VEhdkAS6EPFLC1PHnBqCXEpPxuEb';
    }
    const getAccountMeta = (0, shared_1.getAccountMetaFactory)(programAddress, 'programId');
    const instruction = {
        accounts: [
            getAccountMeta(accounts.payer),
            getAccountMeta(accounts.authority),
            getAccountMeta(accounts.mint),
            getAccountMeta(accounts.approveAccount),
            getAccountMeta(accounts.paymentMint),
            getAccountMeta(accounts.distributionTokenAccount),
            getAccountMeta(accounts.authorityTokenAccount),
            getAccountMeta(accounts.distributionAccount),
            getAccountMeta(accounts.systemProgram),
            getAccountMeta(accounts.distributionProgram),
            getAccountMeta(accounts.tokenProgram),
            getAccountMeta(accounts.paymentTokenProgram),
        ],
        programAddress,
        data: getApproveTransferInstructionDataEncoder().encode(args),
    };
    return instruction;
}
exports.getApproveTransferInstruction = getApproveTransferInstruction;
function parseApproveTransferInstruction(instruction) {
    if (instruction.accounts.length < 12) {
        // TODO: Coded error.
        throw new Error('Not enough accounts');
    }
    let accountIndex = 0;
    const getNextAccount = () => {
        const accountMeta = instruction.accounts[accountIndex];
        accountIndex += 1;
        return accountMeta;
    };
    const getNextOptionalAccount = () => {
        const accountMeta = getNextAccount();
        return accountMeta.address === programs_1.WEN_NEW_STANDARD_PROGRAM_ADDRESS
            ? undefined
            : accountMeta;
    };
    return {
        programAddress: instruction.programAddress,
        accounts: {
            payer: getNextAccount(),
            authority: getNextAccount(),
            mint: getNextAccount(),
            approveAccount: getNextAccount(),
            paymentMint: getNextAccount(),
            distributionTokenAccount: getNextOptionalAccount(),
            authorityTokenAccount: getNextOptionalAccount(),
            distributionAccount: getNextAccount(),
            systemProgram: getNextAccount(),
            distributionProgram: getNextAccount(),
            tokenProgram: getNextAccount(),
            paymentTokenProgram: getNextOptionalAccount(),
        },
        data: getApproveTransferInstructionDataDecoder().decode(instruction.data),
    };
}
exports.parseApproveTransferInstruction = parseApproveTransferInstruction;
//# sourceMappingURL=approveTransfer.js.map