"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseBurnMintAccountInstruction = exports.getBurnMintAccountInstruction = exports.getBurnMintAccountInstructionDataCodec = exports.getBurnMintAccountInstructionDataDecoder = exports.getBurnMintAccountInstructionDataEncoder = void 0;
const web3_js_1 = require("@solana/web3.js");
const programs_1 = require("../programs");
const shared_1 = require("../shared");
function getBurnMintAccountInstructionDataEncoder() {
    return (0, web3_js_1.transformEncoder)((0, web3_js_1.getStructEncoder)([['discriminator', (0, web3_js_1.fixEncoderSize)((0, web3_js_1.getBytesEncoder)(), 8)]]), (value) => ({
        ...value,
        discriminator: new Uint8Array([60, 58, 247, 183, 185, 54, 114, 131]),
    }));
}
exports.getBurnMintAccountInstructionDataEncoder = getBurnMintAccountInstructionDataEncoder;
function getBurnMintAccountInstructionDataDecoder() {
    return (0, web3_js_1.getStructDecoder)([
        ['discriminator', (0, web3_js_1.fixDecoderSize)((0, web3_js_1.getBytesDecoder)(), 8)],
    ]);
}
exports.getBurnMintAccountInstructionDataDecoder = getBurnMintAccountInstructionDataDecoder;
function getBurnMintAccountInstructionDataCodec() {
    return (0, web3_js_1.combineCodec)(getBurnMintAccountInstructionDataEncoder(), getBurnMintAccountInstructionDataDecoder());
}
exports.getBurnMintAccountInstructionDataCodec = getBurnMintAccountInstructionDataCodec;
function getBurnMintAccountInstruction(input) {
    // Program address.
    const programAddress = programs_1.WEN_NEW_STANDARD_PROGRAM_ADDRESS;
    // Original accounts.
    const originalAccounts = {
        payer: { value: input.payer ?? null, isWritable: true },
        user: { value: input.user ?? null, isWritable: false },
        mint: { value: input.mint ?? null, isWritable: true },
        mintTokenAccount: {
            value: input.mintTokenAccount ?? null,
            isWritable: true,
        },
        manager: { value: input.manager ?? null, isWritable: false },
        tokenProgram: { value: input.tokenProgram ?? null, isWritable: false },
    };
    const accounts = originalAccounts;
    // Resolve default values.
    if (!accounts.tokenProgram.value) {
        accounts.tokenProgram.value =
            'TokenzQdBNbLqP5VEhdkAS6EPFLC1PHnBqCXEpPxuEb';
    }
    const getAccountMeta = (0, shared_1.getAccountMetaFactory)(programAddress, 'programId');
    const instruction = {
        accounts: [
            getAccountMeta(accounts.payer),
            getAccountMeta(accounts.user),
            getAccountMeta(accounts.mint),
            getAccountMeta(accounts.mintTokenAccount),
            getAccountMeta(accounts.manager),
            getAccountMeta(accounts.tokenProgram),
        ],
        programAddress,
        data: getBurnMintAccountInstructionDataEncoder().encode({}),
    };
    return instruction;
}
exports.getBurnMintAccountInstruction = getBurnMintAccountInstruction;
function parseBurnMintAccountInstruction(instruction) {
    if (instruction.accounts.length < 6) {
        // TODO: Coded error.
        throw new Error('Not enough accounts');
    }
    let accountIndex = 0;
    const getNextAccount = () => {
        const accountMeta = instruction.accounts[accountIndex];
        accountIndex += 1;
        return accountMeta;
    };
    return {
        programAddress: instruction.programAddress,
        accounts: {
            payer: getNextAccount(),
            user: getNextAccount(),
            mint: getNextAccount(),
            mintTokenAccount: getNextAccount(),
            manager: getNextAccount(),
            tokenProgram: getNextAccount(),
        },
        data: getBurnMintAccountInstructionDataDecoder().decode(instruction.data),
    };
}
exports.parseBurnMintAccountInstruction = parseBurnMintAccountInstruction;
//# sourceMappingURL=burnMintAccount.js.map