"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseCreateGroupAccountInstruction = exports.getCreateGroupAccountInstruction = exports.getCreateGroupAccountInstructionDataCodec = exports.getCreateGroupAccountInstructionDataDecoder = exports.getCreateGroupAccountInstructionDataEncoder = void 0;
const web3_js_1 = require("@solana/web3.js");
const programs_1 = require("../programs");
const shared_1 = require("../shared");
function getCreateGroupAccountInstructionDataEncoder() {
    return (0, web3_js_1.transformEncoder)((0, web3_js_1.getStructEncoder)([
        ['discriminator', (0, web3_js_1.fixEncoderSize)((0, web3_js_1.getBytesEncoder)(), 8)],
        ['name', (0, web3_js_1.addEncoderSizePrefix)((0, web3_js_1.getUtf8Encoder)(), (0, web3_js_1.getU32Encoder)())],
        ['symbol', (0, web3_js_1.addEncoderSizePrefix)((0, web3_js_1.getUtf8Encoder)(), (0, web3_js_1.getU32Encoder)())],
        ['uri', (0, web3_js_1.addEncoderSizePrefix)((0, web3_js_1.getUtf8Encoder)(), (0, web3_js_1.getU32Encoder)())],
        ['maxSize', (0, web3_js_1.getU32Encoder)()],
    ]), (value) => ({
        ...value,
        discriminator: new Uint8Array([34, 65, 118, 12, 64, 190, 211, 145]),
    }));
}
exports.getCreateGroupAccountInstructionDataEncoder = getCreateGroupAccountInstructionDataEncoder;
function getCreateGroupAccountInstructionDataDecoder() {
    return (0, web3_js_1.getStructDecoder)([
        ['discriminator', (0, web3_js_1.fixDecoderSize)((0, web3_js_1.getBytesDecoder)(), 8)],
        ['name', (0, web3_js_1.addDecoderSizePrefix)((0, web3_js_1.getUtf8Decoder)(), (0, web3_js_1.getU32Decoder)())],
        ['symbol', (0, web3_js_1.addDecoderSizePrefix)((0, web3_js_1.getUtf8Decoder)(), (0, web3_js_1.getU32Decoder)())],
        ['uri', (0, web3_js_1.addDecoderSizePrefix)((0, web3_js_1.getUtf8Decoder)(), (0, web3_js_1.getU32Decoder)())],
        ['maxSize', (0, web3_js_1.getU32Decoder)()],
    ]);
}
exports.getCreateGroupAccountInstructionDataDecoder = getCreateGroupAccountInstructionDataDecoder;
function getCreateGroupAccountInstructionDataCodec() {
    return (0, web3_js_1.combineCodec)(getCreateGroupAccountInstructionDataEncoder(), getCreateGroupAccountInstructionDataDecoder());
}
exports.getCreateGroupAccountInstructionDataCodec = getCreateGroupAccountInstructionDataCodec;
function getCreateGroupAccountInstruction(input) {
    // Program address.
    const programAddress = programs_1.WEN_NEW_STANDARD_PROGRAM_ADDRESS;
    // Original accounts.
    const originalAccounts = {
        payer: { value: input.payer ?? null, isWritable: true },
        authority: { value: input.authority ?? null, isWritable: false },
        receiver: { value: input.receiver ?? null, isWritable: false },
        group: { value: input.group ?? null, isWritable: true },
        mint: { value: input.mint ?? null, isWritable: true },
        mintTokenAccount: {
            value: input.mintTokenAccount ?? null,
            isWritable: true,
        },
        manager: { value: input.manager ?? null, isWritable: false },
        systemProgram: { value: input.systemProgram ?? null, isWritable: false },
        associatedTokenProgram: {
            value: input.associatedTokenProgram ?? null,
            isWritable: false,
        },
        tokenProgram: { value: input.tokenProgram ?? null, isWritable: false },
    };
    const accounts = originalAccounts;
    // Original args.
    const args = { ...input };
    // Resolve default values.
    if (!accounts.systemProgram.value) {
        accounts.systemProgram.value =
            '11111111111111111111111111111111';
    }
    if (!accounts.associatedTokenProgram.value) {
        accounts.associatedTokenProgram.value =
            'ATokenGPvbdGVxr1b2hvZbsiqW5xWH25efTNsLJA8knL';
    }
    if (!accounts.tokenProgram.value) {
        accounts.tokenProgram.value =
            'TokenzQdBNbLqP5VEhdkAS6EPFLC1PHnBqCXEpPxuEb';
    }
    const getAccountMeta = (0, shared_1.getAccountMetaFactory)(programAddress, 'programId');
    const instruction = {
        accounts: [
            getAccountMeta(accounts.payer),
            getAccountMeta(accounts.authority),
            getAccountMeta(accounts.receiver),
            getAccountMeta(accounts.group),
            getAccountMeta(accounts.mint),
            getAccountMeta(accounts.mintTokenAccount),
            getAccountMeta(accounts.manager),
            getAccountMeta(accounts.systemProgram),
            getAccountMeta(accounts.associatedTokenProgram),
            getAccountMeta(accounts.tokenProgram),
        ],
        programAddress,
        data: getCreateGroupAccountInstructionDataEncoder().encode(args),
    };
    return instruction;
}
exports.getCreateGroupAccountInstruction = getCreateGroupAccountInstruction;
function parseCreateGroupAccountInstruction(instruction) {
    if (instruction.accounts.length < 10) {
        // TODO: Coded error.
        throw new Error('Not enough accounts');
    }
    let accountIndex = 0;
    const getNextAccount = () => {
        const accountMeta = instruction.accounts[accountIndex];
        accountIndex += 1;
        return accountMeta;
    };
    return {
        programAddress: instruction.programAddress,
        accounts: {
            payer: getNextAccount(),
            authority: getNextAccount(),
            receiver: getNextAccount(),
            group: getNextAccount(),
            mint: getNextAccount(),
            mintTokenAccount: getNextAccount(),
            manager: getNextAccount(),
            systemProgram: getNextAccount(),
            associatedTokenProgram: getNextAccount(),
            tokenProgram: getNextAccount(),
        },
        data: getCreateGroupAccountInstructionDataDecoder().decode(instruction.data),
    };
}
exports.parseCreateGroupAccountInstruction = parseCreateGroupAccountInstruction;
//# sourceMappingURL=createGroupAccount.js.map