"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseExecuteInstruction = exports.getExecuteInstruction = exports.getExecuteInstructionDataCodec = exports.getExecuteInstructionDataDecoder = exports.getExecuteInstructionDataEncoder = void 0;
const web3_js_1 = require("@solana/web3.js");
const programs_1 = require("../programs");
const shared_1 = require("../shared");
function getExecuteInstructionDataEncoder() {
    return (0, web3_js_1.transformEncoder)((0, web3_js_1.getStructEncoder)([
        ['discriminator', (0, web3_js_1.fixEncoderSize)((0, web3_js_1.getBytesEncoder)(), 8)],
        ['amount', (0, web3_js_1.getU64Encoder)()],
    ]), (value) => ({
        ...value,
        discriminator: new Uint8Array([105, 37, 101, 197, 75, 251, 102, 26]),
    }));
}
exports.getExecuteInstructionDataEncoder = getExecuteInstructionDataEncoder;
function getExecuteInstructionDataDecoder() {
    return (0, web3_js_1.getStructDecoder)([
        ['discriminator', (0, web3_js_1.fixDecoderSize)((0, web3_js_1.getBytesDecoder)(), 8)],
        ['amount', (0, web3_js_1.getU64Decoder)()],
    ]);
}
exports.getExecuteInstructionDataDecoder = getExecuteInstructionDataDecoder;
function getExecuteInstructionDataCodec() {
    return (0, web3_js_1.combineCodec)(getExecuteInstructionDataEncoder(), getExecuteInstructionDataDecoder());
}
exports.getExecuteInstructionDataCodec = getExecuteInstructionDataCodec;
function getExecuteInstruction(input) {
    // Program address.
    const programAddress = programs_1.WEN_NEW_STANDARD_PROGRAM_ADDRESS;
    // Original accounts.
    const originalAccounts = {
        sourceAccount: { value: input.sourceAccount ?? null, isWritable: false },
        mint: { value: input.mint ?? null, isWritable: false },
        destinationAccount: {
            value: input.destinationAccount ?? null,
            isWritable: false,
        },
        ownerDelegate: { value: input.ownerDelegate ?? null, isWritable: false },
        extraMetasAccount: {
            value: input.extraMetasAccount ?? null,
            isWritable: false,
        },
    };
    const accounts = originalAccounts;
    // Original args.
    const args = { ...input };
    const getAccountMeta = (0, shared_1.getAccountMetaFactory)(programAddress, 'programId');
    const instruction = {
        accounts: [
            getAccountMeta(accounts.sourceAccount),
            getAccountMeta(accounts.mint),
            getAccountMeta(accounts.destinationAccount),
            getAccountMeta(accounts.ownerDelegate),
            getAccountMeta(accounts.extraMetasAccount),
        ],
        programAddress,
        data: getExecuteInstructionDataEncoder().encode(args),
    };
    return instruction;
}
exports.getExecuteInstruction = getExecuteInstruction;
function parseExecuteInstruction(instruction) {
    if (instruction.accounts.length < 5) {
        // TODO: Coded error.
        throw new Error('Not enough accounts');
    }
    let accountIndex = 0;
    const getNextAccount = () => {
        const accountMeta = instruction.accounts[accountIndex];
        accountIndex += 1;
        return accountMeta;
    };
    return {
        programAddress: instruction.programAddress,
        accounts: {
            sourceAccount: getNextAccount(),
            mint: getNextAccount(),
            destinationAccount: getNextAccount(),
            ownerDelegate: getNextAccount(),
            extraMetasAccount: getNextAccount(),
        },
        data: getExecuteInstructionDataDecoder().decode(instruction.data),
    };
}
exports.parseExecuteInstruction = parseExecuteInstruction;
//# sourceMappingURL=execute.js.map